---
schema_version: "1"
id: 5926c8c7fcb20e76cd57eb55979ee577d67f33ebe4c43260adaa6d64a595da3c
title: TMF645 v4 Service Qualification (Outbound)
collection: developer
version: current
locale: en-us
portal_url: https://docs.salesforce.com/developer/current/en-us/industries-integrations/comms/references/generated-api-specs/tmf645.md
canonical_url: https://developer.salesforce.com/docs/industries/communications/references/tmf645
source_site: developer.salesforce.com
content_type: documentation
content_hash: 477fdce879398762f90cde5649b8a3599d9d5890dda1e6196b7afd8d361c41a8
products:
  - Communications Cloud TM Forum API
  - Industries Integrations
---
TMF645 v4 Service Qualification (Outbound)

# TMF645 v4 Service Qualification (Outbound)

Use the Service Qualification API to check the service eligibility of a configured service or a list of services. Get the qualification result in the response and also check for an unavailability response or an alternate proposal.

**Version:** v1

Protocols: https.

## Operations

### GET Retrieve the service eligibility for a location

`GET /checkServiceQualification`

Retrieves the CheckServiceQualification object or a collection of CheckServiceQualification objects by using filters.

#### Responses

*   **200** Success
    
    Headers:
    
    *   `X-Result-Count` (integer, required) Specifies the actual number of items returned in the response body.
    *   `X-Total-Count` (integer, required) Specifies the total number of items that match the criteria.
    
    Media type: `application/json`. Schema: `CheckServiceQualification`.
    
    _Example_
    
    ```
    {
      "id": "48",
      "description": "check service qualification for IP",
      "expectedQualificationDate": "2020-04-11T14:23:33.239Z",
      "qualificationResult": "qualified",
      "href": "http://serverlocation:port/serviceQualificationManagement/v4/checkServiceQualification/456",
      "externalId": "CSQ1",
      "expirationDate": "2020-04-24T19:20:39.239Z",
      "estimatedResponseDate": "2020-04-13T14:00:00.218Z",
      "effectiveQualificationDate": "2020-04-11T15:20:39.239Z",
      "checkServiceQualificationDate": "2020-04-10T19:20:39.239Z",
      "@type": "string",
      "@baseType": "string",
      "@schemaLocation": "string",
      "instantSyncQualification": true,
      "provideAlternative": true,
      "provideUnavailabilityReason": true,
      "relatedParty": [
        {
          "id": "456",
          "href": "http://serverlocation:port/partyManagement/v4/party/456",
          "name": "Jean Pontus",
          "role": "Buyer contact",
          "@type": "RelatedParty",
          "@referredType": "Individual"
        }
      ],
      "serviceQualificationItem": [],
      "state": "accepted"  
    }
    ```
    
*   **400** There was an issue with your request.
    
    Media type: `application/json`. Schema: `Error`.
    
    _Example_
    
    ```
    code: "400"
    reason: Bad Request
    ```
    
*   **401** Authorization failed.
    
    Media type: `application/json`. Schema: `Error`.
    
    _Example_
    
    ```
    code: "401"
    reason: Unauthorized
    ```
    
*   **403** Request forbidden.
    
    Media type: `application/json`. Schema: `Error`.
    
    _Example_
    
    ```
    code: "403"
    reason: Forbidden
    ```
    
*   **404** Resource not found.
    
    Media type: `application/json`. Schema: `Error`.
    
    _Example_
    
    ```
    code: "404"
    reason: Not Found
    ```
    
*   **405** Method not allowed.
    
    Media type: `application/json`. Schema: `Error`.
    
    _Example_
    
    ```
    code: "405"
    reason: Method not allowed
    ```
    
*   **409** Resource conflict.
    
    Media type: `application/json`. Schema: `Error`.
    
    _Example_
    
    ```
    code: "409"
    reason: Conflict
    ```
    
*   **500** Unable to complete the request as the server encountered an error.
    
    Media type: `application/json`. Schema: `Error`.
    
    _Example_
    
    ```
    code: "500"
    reason: Unable to complete the request as the server encountered an error
    ```
    

### POST Create a service qualification request

`POST /queryServiceQualification`

Creates a QueryServiceQualification entity.

#### Request body

Media type: `application/json`. Schema: `QueryServiceQualification_Create`.

Specifies the QueryServiceQualification entity to be created.

#### Responses

*   **201** A query service qualification entity is created.
    
    Media type: `application/json`. Schema: `QueryServiceQualification`.
    
*   **200** Request is successful.
    
    Media type: `application/json`. Schema: `QueryServiceQualification`.
    
*   **400** There was an issue with your request.
    
    Media type: `application/json;charset=utf-8`. Schema: `Error`.
    
    _Example_
    
    ```
    code: "400"
    reason: Bad Request
    ```
    
*   **401** Authorization failed.
    
    Media type: `application/json;charset=utf-8`. Schema: `Error`.
    
    _Example_
    
    ```
    code: "401"
    reason: Unauthorized
    ```
    
*   **403** Request forbidden.
    
    Media type: `application/json;charset=utf-8`. Schema: `Error`.
    
    _Example_
    
    ```
    code: "403"
    reason: Forbidden
    ```
    
*   **405** Method not allowed.
    
    Media type: `application/json;charset=utf-8`. Schema: `Error`.
    
    _Example_
    
    ```
    code: "405"
    reason: Method not allowed
    ```
    
*   **409** Resource conflict.
    
    Media type: `application/json;charset=utf-8`. Schema: `Error`.
    
    _Example_
    
    ```
    code: "409"
    reason: Conflict
    ```
    
*   **500** Unable to complete the request as the server encountered an error.
    
    Media type: `application/json;charset=utf-8`. Schema: `Error`.
    
    _Example_
    
    ```
    code: "500"
    reason: Unable to complete the request as the server encountered an error
    ```
    

## Schemas

### CheckServiceQualification

Performs a technical eligibility on service configurations and retrieves the services that are technically available in the context of the interaction, such as a place, party, or service characteristics.

*   `id` (_string_, required) Specifies the unique identifier of the service qualification.
*   `href` (_string_, required) Specifies the hyperlink reference to access the service qualification.
*   `checkServiceQualificationDate` (_datetime_, required) Specifies the date when the service qualification is submitted.
*   `description` (_string_, required) Describes the service qualification.
*   `effectiveQualificationDate` (_datetime_, required) Specifies the effective date of the service qualification completion.
*   `estimatedResponseDate` (_datetime_, required) Specifies the estimated date by when the requester expects a response for the qualification request.
*   `expectedQualificationDate` (_datetime_, required) Specifies the date (DateTime) by when the requester expects a response for the qualification request.
*   `expirationDate` (_datetime_, required) Specifies the date when the qualification response expires.
*   `externalId` (_string_, required) Specifies the identifier provided by the requester.
*   `instantSyncQualification` (_boolean_, required) Indicates whether the requester expects to get a qualification result immediately in the response (true) or not (false). If true, then the response code of 200 indicates a successful operation. Else, a task is created with the response code 201.
*   `provideAlternative` (_boolean_, required) Indicates whether alternative solutions are provided (true) or not (false).  
    Default: `false`.
*   `provideUnavailabilityReason` (_boolean_, required) Indicates whether the unavailability reason is expected for unavailable service (true) or not (false).  
    Default: `false`.
*   `qualificationResult` (_string_, required) Specifies the qualification result for the service qualification. Possible values are qualified (all qualification items are qualified), alternate (at least one item is alternate and no item is unqualified), or unqualified (at least one item is unqualified).
*   `relatedParty` (_array of object_, required) Defines a list of related party references that defines a party or party role linked to the request.
    
    Includes all fields of `RelatedParty`.
    
*   `serviceQualificationItem` (_array of object_, required) Specifies the service qualification items.
    
    Includes all fields of `CheckServiceQualificationItem`.
    
*   `state` (_TaskStateType (string)_, required) Specifies the state of the service qualification. Possible values are acknowledged, inProgress, terminatedWithError, or done.
*   `@baseType` (_string_, required) Defines the super class when subclassing.
*   `@schemaLocation` (_string_, required) Specifies the URI to a JSON schema file that defines additional attributes and relationships.
*   `@type` (_string_, required) Defines the subclass entity name when subclassing.

### Error

Shown when an API throws an error, typically with an HTTP error response-code (3xx, 4xx, or 5xx).

*   `code` (_string_, required) Specifies the application-relevant detail defined in the API or a common list.
*   `reason` (_string_, required) Describes the reason for the error, which can be shown to a client user.
*   `message` (_string_) Provides more details and corrective actions related to the error, which can be shown to a client user.
*   `status` (_string_) Specifies the HTTP error code extension.
*   `referenceError` (_string_) Specifies the URI of the documentation that describes the error.
*   `baseType` (_string_) Defines the super class when subclassing.
*   `schemaLocation` (_string_) Specifies the URI to a JSON schema file that defines additional attributes and relationships.
*   `@type` (_string_) Defines the subclass entity name when subclassing.

### QueryServiceQualification\_Create

Retrieves a list of services that are technically available in the context of the interaction, such as a place, a party, or service characteristics.

*   `description` (_string_) Describes the service qualification.
*   `expectedQualificationDate` (_datetime_) Specifies the date (DateTime) by when the requester expects a qualification answer.
*   `externalId` (_string_) Specifies the external identifier provided by the requester.
*   `instantSyncQualification` (_boolean_) Indicates whether the requester expects to get a qualification result immediately in the response (true) or not (false). If true, then the response code of 200 indicates a successful operation. Else, a task is created with the response code 201.
*   `relatedParty` (_array of object_) Defines a list of related party references that defines a party or party role linked to the request.
    
    Includes all fields of `RelatedParty`.
    
*   `searchCriteria` (_object_, required) Specifies the search structure to retrieve an eligible service specification.
    
    Includes all fields of `ServiceQualificationItem`.
    
*   `@baseType` (_string_) Defines the super class when subclassing.
*   `@schemaLocation` (_string_) Specifies the URI to a JSON schema file that defines additional attributes and relationships.
*   `@type` (_string_) Defines the subclass entity name when subclassing.

### QueryServiceQualification

Retrieves a list of services that are technically available in the context of the interaction, such as a place, a party, or service characteristics.

*   `id` (_string_, required) Specifies the unique identifier of the service qualification resource.
*   `href` (_string_, required) Specifies the hyperlink reference to access the service qualification.
*   `description` (_string_, required) Describes the service qualification resource.
*   `effectiveQualificationDate` (_datetime_, required) Specifies the effective date of the service qualification completion.
*   `estimatedResponseDate` (_datetime_, required) Specifies the estimated date byewhen the requester expects a response for the qualification request.
*   `expectedQualificationDate` (_datetime_, required) Specifies the date (DateTime) by when the requester expects a qualification answer for the qualification request.
*   `expirationDate` (_datetime_, required) Specifies the date when the qualification response expires.
*   `externalId` (_string_, required) Specifies the external identifier provided by the requester.
*   `instantSyncQualification` (_boolean_, required) Indicates whether the requester expects to get a qualification result immediately in the response (true) or not (false). If true, then the response code of 200 indicates a successful operation. Else, a task is created with the response code 201.
*   `queryServiceQualificationDate` (_datetime_, required) Specifies the date when the service qualification was submitted.
*   `relatedParty` (_array of object_, required) Defines a list of related party references that defines a party or party role linked to the request.
    
    Includes all fields of `RelatedParty`.
    
*   `searchCriteria` (_object_, required) Specifies the search structure to find an eligible service specification.
    
    Includes all fields of `ServiceQualificationItem`.
    
*   `serviceQualificationItem` (_array of object_, required) Specifies the service qualification items.
    
    Includes all fields of `ServiceQualificationItem`.
    
*   `state` (_TaskStateType (string)_, required) Specifies the state of the service qualification. Possible values are acknowledged, inProgress, terminatedWithError, or done.
*   `@baseType` (_string_, required) Defines the super class when subclassing.
*   `@schemaLocation` (_string_, required) Specifies the URI to a JSON schema file that defines additional attributes and relationships.
*   `@type` (_string_, required) Defines the subclass entity name when subclassing.

### RelatedParty

Defines a party or party role that's linked to a specific entity.

*   `id` (_string_, required) Specifies the unique identifier of the related party.
*   `href` (_string_) Specifies the hyperlink reference of the related party.
*   `name` (_string_) Specifies the name of the related entity.
*   `role` (_string_) Specifies the role played by the related party.
*   `@baseType` (_string_) Defines the super class when subclassing.  
    Example: `ResourceSpecificatio`.
*   `@schemaLocation` (_string_) Specifies the URI to a JSON schema file that defines additional attributes and relationships.  
    Example: `https://mycsp.com:8080/tmf-api/schema/Resource/LogicalResourceSpecification.schema.json`.
*   `@type` (_string_) Defines the subclass extensible name when subclassing.  
    Example: `LogicalResourceSpecification`.
*   `@referredType` (_string_, required) The actual type of the target instance when needed for disambiguation.

### CheckServiceQualificationItem

A service qualification item that relates to a specific service being checked in a qualification operation.

*   `id` (_string_, required) Specifies the unique identifier of the service qualification item.
*   `expectedActivationDate` (_datetime_, required) Specifies the date when the service is expected to be activated.
*   `expectedServiceAvailabilityDate` (_datetime_, required) Specifies the date when the requester looks for service availability.
*   `expirationDate` (_datetime_, required) Specifies the date when the qualification item response expires.
*   `qualificationResult` (_string_, required) Specifies the qualification result for the service qualification item. Possible values are qualified (request service is available), unqualified (requested not available and no alternate available), or alternate (requested and not available but proposal available).
*   `state` (_string_, required) Specifies the state of the service qualification item. Possible values are acknowledged, inProgress, terminatedWithError, and done.
*   `alternateServiceProposal` (_array of object_, required) Alternate service proposal is used when the requested service isn't available with the characteristic and for the requested date. An alternate proposal can be a distinct service specification close to the requested proposal or the same as the requested proposal but with a different availability date.
    
    Includes all fields of `AlternateServiceProposal`.
    
*   `category` (_object_, required) Groups product offerings, service, and resource candidates in logical containers. Categories can contain other categories or product offerings, resource, or service candidates.
    
    Includes all fields of `ServiceCategoryRef`.
    
*   `eligibilityUnavailabilityReason` (_array of object_, required) Specifies a list of eligibility unavailability reasons (EligibilityUnavailabilityReason \[\*\]) if the service qualification result is no, which means the service isn't available.
    
    Includes all fields of `ServiceEligibilityUnavailabilityReason`.
    
*   `qualificationItemRelationship` (_array of object_, required) Specifies a list of qualification item relationships to describe the relationship between the service qualification items from the same service qualification.
    
    Includes all fields of `ServiceQualificationItemRelationship`.
    
*   `qualificationRelationship` (_array of object_, required) Specifies a structure that's used to describe the relationship between the service qualification items from the same service qualification.
    
    Includes all fields of `ServiceQualificationRelationship`.
    
*   `service` (_object_, required) Configures the service characteristics or identifies the service that you want to modify or delete. You can configure only certain characteristics. Configuration is required only if a nondefault value is selected.
    
    Includes all fields of `ServiceRefOrValue`.
    
*   `terminationError` (_array of object_, required) If qualification item isn't completed properly, the termination error lists the errors that caused the termination of the qualification.
    
    Includes all fields of `TerminationError`.
    
*   `@baseType` (_string_, required) Defines the super class when subclassing.
*   `@schemaLocation` (_string_, required) Specifies the URI to a JSON schema file that defines additional attributes and relationships.
*   `@type` (_string_, required) Defines the subclass entity name when subclassing.

### TaskStateType

Specifies the state of a task. Possible values are accepted, terminatedWithError, inProgress, or done.

Type: `string`.

Allowed values: `accepted`, `terminatedWithError`, `inProgress`, `done`.

### ServiceQualificationItem

Specifies the service qualification item relating to a specific service being checked in a qualification operation.

*   `id` (_string_) Specifies the ID of the service qualification item.
*   `expectedActivationDate` (_datetime_) Specifies the expected date of the service activation.
*   `expectedServiceAvailabilityDate` (_datetime_) Specifies the date when the requester looks for the service availability.
*   `expirationDate` (_datetime_) Specifies the date when the qualification item response expires.
*   `category` (_object_) Groups product offerings and service and resource candidates in logical containers. Categories can contain other categories or product offerings and resource or service candidates.
    
    Includes all fields of `ServiceCategoryRef`.
    
*   `service` (_object_) Configures the configurable service characteristics, necessary only if a non default value is selected or identifies the service to be modified or deleted.
    
    Includes all fields of `ServiceRefOrValue`.
    
*   `@baseType` (_string_) Defines the super class when subclassing.
*   `@schemaLocation` (_string_) Specifies the URI to a JSON schema file that defines additional attributes and relationships.
*   `@type` (_string_) Defines the subclass entity name when subclassing.

### AlternateServiceProposal

Alternate service proposal is used when the requested service isn't available with the characteristic and for the requested date. An alternate proposal can be a distinct service specification close to the requested proposal or the same as the requested proposal but with a different activation date.

*   `id` (_string_, required) Specifies the identifier of an alternate service proposal.
*   `alternateServiceAvailabilityDate` (_datetime_, required) Specifies the alternate availability date if the seller isn't able to meet the expected availability date for the service.
*   `alternateService` (_object_, required)
    
    Includes all fields of `ServiceRefOrValue`.
    
*   `@baseType` (_string_, required) Defines the super class when subclassing.
*   `@schemaLocation` (_string_, required) Specifies the URI to a JSON schema file that defines additional attributes and relationships.
*   `@type` (_string_, required) Defines the subclass entity name when subclassing.

### ServiceCategoryRef

Groups the service candidates in logical containers. Categories can contain other categories.

*   `id` (_string_, required) Specifies the unique identifier of the service category.
*   `href` (_string_) Specifies the hyperlink reference of the service category.
*   `name` (_string_) Specifies the name of the related entity.
*   `version` (_string_) Specifies the category version.
*   `@baseType` (_string_) Defines the super class when subclassing.  
    Example: `ResourceSpecification`.
*   `@schemaLocation` (_string_) Specifies the URI to a JSON schema file that defines additional attributes and relationships.  
    Example: `https://mycsp.com:8080/tmf-api/schema/Resource/LogicalResourceSpecification.schema.json`.
*   `@type` (_string_) Defines the subclass extensible name when subclassing.  
    Example: `LogicalResourceSpecification`.
*   `@referredType` (_string_) The actual type of the target instance when needed for disambiguation.

### ServiceEligibilityUnavailabilityReason

Describes the reason for eligibility result if the service qualification result is no or the service isn't available.

*   `code` (_string_, required) Specifies the code for the unavailability reason.
*   `label` (_string_, required) Specifies the label for the unavailability reason.
*   `@baseType` (_string_, required) Defines the super class when subclassing.
*   `@schemaLocation` (_string_, required) Specifies the URI to a JSON schema file that defines additional attributes and relationships.
*   `@type` (_string_, required) Defines the subclass entity name when subclassing.

### ServiceQualificationItemRelationship

Describes the structure that defines the relationship between the service qualification items from the same service qualification.

*   `id` (_string_, required) Specifies the identifier of the service qualification item from the same service qualification.
*   `relationshipType` (_string_, required) Specifies the type of relationship, such as reliesOn or connectedTo.
*   `@baseType` (_string_, required) Defines the super class when subclassing.
*   `@schemaLocation` (_string_, required) Specifies the URI to a JSON schema file that defines additional attributes and relationships.
*   `@type` (_string_, required) Defines the subclass entity name when subclassing.

### ServiceQualificationRelationship

Specifies the service qualification relationship.

*   `id` (_string_, required) Specifies the identifier of the target qualification pointed to by this relationship.
*   `relationshipType` (_string_, required) Specifies the type of relationship.
*   `@baseType` (_string_, required) Defines the super class when subclassing.
*   `@schemaLocation` (_string_, required) Specifies the URI to a JSON schema file that defines additional attributes and relationships.
*   `@type` (_string_, required) Defines the subclass entity name when subclassing.

### ServiceRefOrValue

A service to be created that is defined by a value or uses the existing service defined by a reference. The polymorphic attributes @type, @schemaLocation, and @referredType are related to the service entity and not to the RelatedServiceRefOrValue class itself.

*   `id` (_string_) Specifies the unique identifier of the service.
*   `href` (_string_) Specifies the reference of the service.
*   `category` (_string_) Specifies whether the category is a customer-facing or resource-facing service.
*   `description` (_string_) Specifies the text description of the service.
*   `endDate` (_datetime_) Specifies the end date of the service.
*   `hasStarted` (_boolean_) Indicates whether the service has started (true) or not (false).
*   `isBundle` (_boolean_) Indicates whether the service is a Servicebundle (true) or an atomic service with leaf hierarchy (false). A ServiceBundle regroups a service hierarchy.
*   `isServiceEnabled` (_boolean_) Specifies if the service is enabled for use or has failed. If the isServiceEnabled and hasStarted fields are false, the service is not enabled for use. If the isServiceEnabled field is false and the hasStarted field is true, then the service has failed.
*   `isStateful` (_boolean_) Specifies whether the service can be changed without affecting any other services (true) or not (false).
*   `name` (_string_) Specifies the name of the service.
*   `serviceDate` (_string_) Specifies the date when the service is created irrespective of the service status.
*   `serviceType` (_string_) Specifies the business type of the service.
*   `startDate` (_datetime_) Specifies the start date of the service.
*   `startMode` (_string_) An enumerated integer that indicates how the service is started, such as: 0: Unknown; 1: Automatically by the managed environment; 2: Automatically by the owning device; 3: Manually by the Provider of the Service; 4: Manually by a Customer of the Provider; or 5: Any of the above.
*   `feature` (_array of object_) Specifies a list of features related to the service.
    
    Includes all fields of `Feature`.
    
*   `note` (_array of object_) Specifies a list of notes made about the service.
    
    Includes all fields of `Note`.
    
*   `place` (_array of object_) Defines a list of places (Place \[\*\]) useful for the service. For example, a geographical place where the service is installed.
    
    Includes all fields of `RelatedPlaceRefOrValue`.
    
*   `relatedEntity` (_array of object_) Defines a list of related entities in relationship with the service.
    
    Includes all fields of `RelatedEntityRefOrValue`.
    
*   `relatedParty` (_array of object_) Defines a list of related party references (RelatedParty \[\*\]) that defines a party or party role linked to a specific entity.
    
    Includes all fields of `RelatedParty`.
    
*   `serviceCharacteristic` (_array of object_) Defines a list of characteristics that characterize the service (ServiceCharacteristic \[\*\]).
    
    Includes all fields of `Characteristic`.
    
*   `serviceOrderItem` (_array of object_) Specifies a list of service order items related to the service.
    
    Includes all fields of `RelatedServiceOrderItem`.
    
*   `serviceRelationship` (_array of object_) Defines a list of service relationships (ServiceRelationship \[\*\]) that describes links with other services in the inventory.
    
    Includes all fields of `ServiceRelationship`.
    
*   `serviceSpecification` (_object_) The specification from which this service is instantiated.
    
    Includes all fields of `ServiceSpecificationRef`.
    
*   `state` (_ServiceStateType (string)_) Specifies the life cycle state of the service, such as designed, reserved, or active.
*   `supportingResource` (_array of object_) Specifies a list of supporting resources (SupportingResource \[\*\]).Note: Only services of the type RFS can be related to the resources.
    
    Includes all fields of `ResourceRef`.
    
*   `supportingService` (_array of object_) Defines a list of supporting services (SupportingService \[\*\]), which is a collection of services that support this service (bundling or linking CFS to RFS).
    
    Includes all fields of `ServiceRefOrValue`.
    
*   `@baseType` (_string_) Defines the super class when subclassing.  
    Example: `ResourceSpecification`.
*   `@schemaLocation` (_string_) Specifies the URI to a JSON schema file that defines additional attributes and relationships.  
    Example: `https://mycsp.com:8080/tmf-api/schema/Resource/LogicalResourceSpecification.schema.json`.
*   `@type` (_string_) Defines the subclass extensible name when subclassing.  
    Example: `LogicalResourceSpecification`.
*   `@referredType` (_string_) The actual type of the target instance when needed for disambiguation.

### TerminationError

Indicates an error that caused a qualification item to terminate.

*   `id` (_string_, required) Specifies the unique identifier of the termination error.
*   `value` (_string_, required) Describes the text for the termination error. Example - Unable to proceed to qualification due to incomplete information.
*   `@baseType` (_string_, required) Defines the super class when subclassing.
*   `@schemaLocation` (_string_, required) Specifies the URI to a JSON schema file that defines additional attributes and relationships.
*   `@type` (_string_, required) Defines the subclass entity name when subclassing.

### Feature

Describes the feature.

*   `id` (_string_) Specifies the unique identifier of the feature.
*   `isBundle` (_boolean_) Indicates whether the feature is a feature group (true) or not (false). The default value is false.
*   `isEnabled` (_boolean_) Indicates whether the feature is enabled (true) or not (false). The default value is true.
*   `name` (_string_, required) Specifies the name of the feature.
*   `constraint` (_array of object_) Specifies a list of the feature constraints.
    
    Includes all fields of `ConstraintRef`.
    
*   `featureCharacteristic` (_array of object_, required) Specifies a list of characteristics for a feature.  
    Minimum items: 1.
    
    Includes all fields of `Characteristic`.
    
*   `featureRelationship` (_array of object_)
    
    Includes all fields of `FeatureRelationship`.
    
*   `@baseType` (_string_) Defines the super class when subclassing.
*   `@schemaLocation` (_string_) Specifies the URI to a JSON schema file that defines additional attributes and relationships.
*   `@type` (_string_) Defines the subclass entity name when subclassing.

### Note

Provides additional information about a given entity.

*   `id` (_string_, required) Specifies the identifier of the note within its containing entity, which isn’t necessarily unique globally, depending on the provider implementation.
*   `author` (_string_, required) Specifies the author of the note.
*   `date` (_datetime_, required) Specifies the date of the note.
*   `text` (_string_, required) Specifies the text of the note.
*   `@baseType` (_string_, required) Defines the super class when subclassing.
*   `@schemaLocation` (_string_, required) Specifies the URI to a JSON schema file that defines additional attributes and relationships.
*   `@type` (_string_, required) Defines the subclass entity name when subclassing.

### RelatedPlaceRefOrValue

Defines a place described by reference or by value that is linked to a specific entity. The polymorphic attributes @type, @schemaLocation, and @referredType are related to the place entity and not to the RelatedPlaceRefOrValue class itself.

*   `id` (_string_) Specifies the unique identifier of the place.
*   `href` (_string_) Specifies the unique reference of the place.
*   `name` (_string_) Specifies a user-friendly name for the place, such as Paris Store, London Store, or Main Home.
*   `role` (_string_, required)
*   `@baseType` (_string_) Defines the super class when subclassing.  
    Example: `ResourceSpecification`.
*   `@schemaLocation` (_string_) Specifies the URI to a JSON schema file that defines additional attributes and relationships.  
    Example: `https://mycsp.com:8080/tmf-api/schema/Resource/LogicalResourceSpecification.schema.json`.
*   `@type` (_string_) Defines the subclass extensible name when subclassing.  
    Example: `LogicalResourceSpecification`.
*   `@referredType` (_string_) The actual type of the target instance when needed for disambiguation.

### RelatedEntityRefOrValue

A reference to an entity, where the type of the entity is not known in advance. A related entity defines an entity described by reference or by value that is linked to a specific entity. The polymorphic attributes @type, @schemaLocation, and @referredType are related to the entity and not to the RelatedEntityRefOrValue class itself.

*   `id` (_string_) Specifies the unique identifier of a related entity.
*   `href` (_string_) Specifies the reference of the related entity.
*   `name` (_string_) Specifies the name of the related entity.
*   `role` (_string_, required)
*   `@baseType` (_string_) Defines the super class when subclassing.  
    Example: `ResourceSpecification`.
*   `@schemaLocation` (_string_) Specifies the URI to a JSON schema file that defines additional attributes and relationships.  
    Example: `https://mycsp.com:8080/tmf-api/schema/Resource/LogicalResourceSpecification.schema.json`.
*   `@type` (_string_) Defines the subclass extensible name when subclassing.  
    Example: `LogicalResourceSpecification`.
*   `@referredType` (_string_) The actual type of the target instance when needed for disambiguation.

### Characteristic

Describes a given characteristic of an object or entity through a name or value pair.

*   `id` (_string_) Specifies the unique identifier of the characteristic.
*   `name` (_string_, required) Specifies the name of the characteristic.
*   `valueType` (_string_) Specifies the data type of the value of the characteristic.
*   `characteristicRelationship` (_array of object_)
    
    Includes all fields of `CharacteristicRelationship`.
    
*   `value` (_object_, required) Specifies the value of the characteristic.
    
    Includes all fields of `Any`.
    
*   `@baseType` (_string_) Defines the super class when subclassing.  
    Example: `ResourceSpecification`.
*   `@schemaLocation` (_string_) Specifies the URI to a JSON schema file that defines additional attributes and relationships.  
    Example: `https://mycsp.com:8080/tmf-api/schema/Resource/LogicalResourceSpecification.schema.json`.
*   `@type` (_string_) Defines the subclass extensible name when subclassing.  
    Example: `LogicalResourceSpecification`.

### RelatedServiceOrderItem

Represents the service order item that triggered service creation, change, or termination.

*   `itemId` (_string_, required) Specifies the identifier of the order item where the service is managed.
*   `role` (_string_) Specifies the role of the service order item for the service.
*   `serviceOrderHref` (_string_) Specifies the reference of the related entity.
*   `serviceOrderId` (_string_, required) Specifies the unique identifier of the related entity.
*   `itemAction` (_OrderItemActionType (string)_) Specifies the action of the order item for the service.
*   `@baseType` (_string_) Defines the super class when subclassing.
*   `@schemaLocation` (_string_) Specifies the URI to a JSON schema file that defines additional attributes and relationships.
*   `@type` (_string_) Defines the subclass entity name when subclassing.
*   `@referredType` (_string_) The actual type of the target instance when needed for disambiguation.

### ServiceRelationship

*   `relationshipType` (_string_, required)
*   `service` (_object_)
    
    Includes all fields of `ServiceRefOrValue`.
    
*   `serviceRelationshipCharacteristic` (_array of object_)
    
    Includes all fields of `Characteristic`.
    
*   `@baseType` (_string_) Defines the super class when subclassing.
*   `@schemaLocation` (_string_) Specifies the URI to a JSON schema file that defines additional attributes and relationships.
*   `@type` (_string_) Defines the subclass entity name when subclassing.

### ServiceSpecificationRef

Specifies the ServiceSpecification objects that is required to register a ProductSpecification object.

*   `id` (_string_, required) Specifies the unique identifier of the service specification.
*   `href` (_string_) Specifies the hyperlink reference of the service specification.
*   `name` (_string_) Specifies the name of the related entity.
*   `version` (_string_) Specifies the service specification version.
*   `@baseType` (_string_) Defines the super class when subclassing.  
    Example: `ResourceSpecification`.
*   `@schemaLocation` (_string_) Specifies the URI to a JSON schema file that defines additional attributes and relationships.  
    Example: `https://mycsp.com:8080/tmf-api/schema/Resource/LogicalResourceSpecification.schema.json`.
*   `@type` (_string_) Defines the subclass extensible name when subclassing.  
    Example: `LogicalResourceSpecification`.
*   `@referredType` (_string_) The actual type of the target instance when needed for disambiguation.

### ServiceStateType

Specifies the valid values for the life cycle state of the service. Possible values are feasibilityChecked, designed, reserved, inactive, active, or terminated.

Type: `string`.

Allowed values: `feasibilityChecked`, `designed`, `reserved`, `inactive`, `active`, `terminated`.

### ResourceRef

Specifies the reference of the resource.

*   `id` (_string_, required) Specifies the unique identifier of the resource reference.
*   `href` (_string_) Specifies the hyperlink reference of the resource reference.
*   `name` (_string_) Specifies the name of the related entity.
*   `@baseType` (_string_) Defines the super class when subclassing.  
    Example: `ResourceSpecification`.
*   `@schemaLocation` (_string_) Specifies the URI to a JSON schema file that defines additional attributes and relationships.  
    Example: `https://mycsp.com:8080/tmf-api/schema/Resource/LogicalResourceSpecification.schema.json`.
*   `@type` (_string_) Defines the subclass extensible name when subclassing.  
    Example: `LogicalResourceSpecification`.
*   `@referredType` (_string_) The actual type of the target instance when needed for disambiguation.

### ConstraintRef

Represents a policy or rule applied to an entity or entity spec.

*   `id` (_string_, required) Specifies the reference id of the target constraint.
*   `href` (_string_) Specifies the hyperlink reference of the target constraint.
*   `name` (_string_) Specifies the name of the constraint.
*   `version` (_string_) Specifies the constraint version.
*   `@baseType` (_string_) Defines the super class when subclassing.
*   `@schemaLocation` (_string_) Specifies the URI to a JSON schema file that defines additional attributes and relationships.
*   `@type` (_string_) Defines the subclass entity name when subclassing.
*   `@referredType` (_string_) Specifies the class type of the referred constraint.

### FeatureRelationship

Specifies the configuration feature.

*   `id` (_string_) Specifies the unique identifier of the target feature.
*   `name` (_string_, required) Specifies the name of the target feature.
*   `relationshipType` (_string_, required) Specifies the type of the feature relationship.
*   `validFor` (_object_) Specifies the period for which the feature relationship is valid.
    
    Includes all fields of `TimePeriod`.
    
*   `@baseType` (_string_) Defines the super class when subclassing.
*   `@schemaLocation` (_string_) Specifies the URI to a JSON schema file that defines additional attributes and relationships.
*   `@type` (_string_) Defines the subclass entity name when subclassing.

### CharacteristicRelationship

Specifies another characteristic related to the current characteristic.

*   `id` (_string_, required) Specifies the unique identifier of the characteristic.
*   `relationshipType` (_string_, required) Specifies the type of relationship.
*   `@baseType` (_string_, required) Defines the super class when subclassing.
*   `@schemaLocation` (_string_, required) Specifies the URI to a JSON schema file that defines additional attributes and relationships.
*   `@type` (_string_, required) Defines the subclass entity name when subclassing.

### Any

### OrderItemActionType

Specifies the action to perform on the product. Possible values are add, modify, delete, or noChange.

Type: `string`.

Allowed values: `add`, `modify`, `delete`, `noChange`.

### TimePeriod

Specifies a period as a deadline - endDateTime only, startDateTime only, or both.

*   `endDateTime` (_datetime_, required) Specifies the end of the period by using the IETC-RFC-3339 format.  
    Example: `1985-04-12T23:20:50.52Z`.
*   `startDateTime` (_datetime_, required) Specifies the start of the period by using the IETC-RFC-3339 format.  
    Example: `1985-04-12T23:20:50.52Z`.
*   `@baseType` (_string_, required) Defines the super class when subclassing.
*   `@schemaLocation` (_string_, required) Specifies the URI to a JSON schema file that defines additional attributes and relationships.
*   `@type` (_string_, required) Defines the subclass entity name when subclassing.